package edu.gjoko.schedlr.controllers.rest;

import edu.gjoko.schedlr.entity.Business;
import edu.gjoko.schedlr.services.BusinessService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@RestController
@RequestMapping("api/business")
@AllArgsConstructor
public class BusinessApi {

    private final BusinessService businessService;

    @PostMapping
    public void saveBusiness(@RequestBody Business business) {
        businessService.saveBusiness(business);
    }

    @GetMapping
    public List<Business> findAll() {
        return businessService.findAll();
    }

    @PatchMapping
    public void updateBusinesses(@RequestBody List<Business> businessList) {
        businessService.updateBusinesses(businessList);
    }

    @GetMapping(path = "/me")
    public Business getPersonalInfo(HttpServletRequest request) {
        Long businessOwnerId = (long) request.getSession(true).getAttribute("stakeholderId");
        return businessService.findByOwner(businessOwnerId);
    }

    @GetMapping(path = "/{businessTypeId}")
    public List<Business> getBusinessesByBusinessType(@PathVariable("businessTypeId") Long id) {
        return businessService.findByBusinessTypeAndActiveStatus(id);
    }
}
